/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#include <stdio.h>
#include "js-runtimeexception.h"
#include "js-exceptionhandler.h"
#include "js-labeltable.h"

/* Procedures */
int
JSLabelTable::acquireLabel(JSContext *cx)
{
    if (itsLabelTable == NULL) {
	itsLabelTableLength = LabelTableSize;
        itsLabelTable
		= (JSLabel **) JS_NewZoneObj(cx, sizeof (*itsLabelTable)
						* LabelTableSize);
        itsLabelTable[0] = new (cx) JSLabel();
        itsLabelTableTop = 1;
        return 0x80000000;
    } else {
        if (itsLabelTableTop == itsLabelTableLength) {
            JSLabel **oldTable = itsLabelTable;

            itsLabelTable
		= (JSLabel **) JS_NewZoneObj(cx, sizeof (*itsLabelTable)
						* (itsLabelTableTop * 2));
	    memcpy(itsLabelTable, oldTable,
		sizeof (*itsLabelTable) * (itsLabelTableTop * 2));
	    JS_DeleteZoneObj(cx, oldTable);
	    itsLabelTableLength = itsLabelTableTop * 2;
        }
        itsLabelTable[itsLabelTableTop] = new (cx) JSLabel();

        int result = itsLabelTableTop++;

        return result | 0x80000000;
    }
}
int
JSLabelTable::markLabel(JSContext *cx, int theLabel, int pc)
{
    if (DEBUGLABELS) {
        if ((theLabel & 0x80000000) != 0x80000000) {
            cx->exceptionHandler->throwEx(
                    cx,
                    new (cx) JSRuntimeException("Bad label, no biscuit"));
	}
    }
    theLabel &= 0x7FFFFFFF;
    if (DEBUGLABELS) {
        printf("Marking label %d at %d\n", theLabel, pc);
    }
    itsLabelTable[theLabel]->setPC(cx, (short) pc);
    return theLabel | 0x80000000;
}
void
JSLabelTable::destroy(JSContext *cx)
{
    for (int i = 0; i < itsLabelTableTop; ++i) {
        itsLabelTable[i]->destroy(cx);
    }
    if (itsLabelTable != NULL) {
        JS_DeleteZoneObj(cx, itsLabelTable);
    }
    JSZoneNew::destroy(cx);
}

JSLabelTable::JSLabelTable()
{
    itsLabelTableLength = 0;
    itsLabelTable = NULL;
    itsLabelTableTop = 0;
}

